<?php  // $Id: index.php,v 1.1 2008/04/22 18:09:21 stronk7 Exp $

///////////////////////////////////////////////////////////////////////////
//                                                                       //
// NOTICE OF COPYRIGHT                                                   //
//                                                                       //
// Moodle - Modular Object-Oriented Dynamic Learning Environment         //
//          http://moodle.com                                            //
//                                                                       //
// Copyright (C) 2001-3001 Martin Dougiamas        http://dougiamas.com  //
//           (C) 2001-3001 Eloy Lafuente (stronk7) http://contiento.com  //
//           (C) 2001-3001 Antonio Vicent          http://ludens.es      //
//                                                                       //
// This program is free software; you can redistribute it and/or modify  //
// it under the terms of the GNU General Public License as published by  //
// the Free Software Foundation; either version 2 of the License, or     //
// (at your option) any later version.                                   //
//                                                                       //
// This program is distributed in the hope that it will be useful,       //
// but WITHOUT ANY WARRANTY; without even the implied warranty of        //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         //
// GNU General Public License for more details:                          //
//                                                                       //
//          http://www.gnu.org/copyleft/gpl.html                         //
//                                                                       //
///////////////////////////////////////////////////////////////////////////

/// On simple course report to show the number of log entries per
/// student on one course. Downloadable in various formats.

    require_once('../../../config.php');
    require_once($CFG->libdir.'/tablelib.php');
    require_once($CFG->libdir.'/excellib.class.php');
    require_once($CFG->libdir.'/odslib.class.php');

    $id  = required_param('id', PARAM_INT); // course id.
    $out = optional_param('out', 'html', PARAM_TAG);   // output (html, xls, ods, txt) defaults to html

    if (!$course = get_record('course', 'id', $id)) {
        print_error('invalidcourse');
    }

    require_login($course);
    $context = get_context_instance(CONTEXT_COURSE, $course->id);
    require_capability('moodle/site:viewreports', $context);

    $groupmode    = groups_get_course_groupmode($course);   // Groups are being used
    $currentgroup = groups_get_course_group($course, true); // Fetches current selected group
    if (!$currentgroup) {      // To make some other functions work better later
        $currentgroup  = NULL;
    }
    $isseparategroups = ($course->groupmode == SEPARATEGROUPS and $course->groupmodeforce and
                             !has_capability('moodle/site:accessallgroups', $context)); // Not used but I left it here

    add_to_log($course->id, "course", "report rawrecordscount", "report/rawrecordscount/index.php?id=$course->id", $course->id);

    $strparticipation = get_string('rawrecordscount', 'report_rawrecordscount');
    $strfilename = get_string('rawrecordsreportfilename', 'report_rawrecordscount');
    $strreports       = get_string('reports');

/// Recordset (common for all outputs)
    $fromgroups = '';
    $wheregroups = '';
    if ($currentgroup) {
        $fromgroups = 'LEFT JOIN '.$CFG->prefix.'groups_members gm ON u.id = gm.userid';
        $wheregroups ='AND gm.groupid = '.$currentgroup;
    }

    $sql = "SELECT u.id, u.firstname, u.lastname, u.picture, count(*) as count
              FROM {$CFG->prefix}user u
                   INNER JOIN {$CFG->prefix}log l ON u.id = l.userid
                   $fromgroups
             WHERE l.course = $id
                   $wheregroups
             GROUP BY u.id, u.firstname, u.lastname, u.picture
             ORDER BY u.lastname, u.firstname";

    $rs = get_recordset_sql($sql);

/// Output (different for $out)
    if ($out == 'xls') { /// XLS output
        $workbook = new MoodleExcelWorkbook('-');
        $workbook->send($strfilename . '.xls');
        $worksheet =& $workbook->add_worksheet($strfilename);

        $worksheet->write(0, 0, get_string('users'));
        $worksheet->write(0, 1, get_string('total'));

        $row = 1;

        while ($rec = rs_fetch_next_record($rs)) {

            if (has_capability('moodle/course:manageactivities', $context, $rec->id)) {
                continue;
            }

            $user = new object();
            $user->id = $rec->id;
            $user->firstname = $rec->firstname;
            $user->lastname = $rec->lastname;
            $user->picture = $rec->picture;

            $worksheet->write($row, 0, fullname($user));
            $worksheet->write($row, 1, $rec->count);

            $row++;
        }

        $workbook->close();
    } else if ($out == 'ods') { /// ODS output
        $workbook = new MoodleODSWorkbook('-');
        $workbook->send($strfilename . '.ods');
        $worksheet =& $workbook->add_worksheet($strfilename);

        $worksheet->write(0, 0, get_string('users'));
        $worksheet->write(0, 1, get_string('total'));

        $row = 1;

        while ($rec = rs_fetch_next_record($rs)) {

            if (has_capability('moodle/course:manageactivities', $context, $rec->id)) {
                continue;
            }

            $user = new object();
            $user->id = $rec->id;
            $user->firstname = $rec->firstname;
            $user->lastname = $rec->lastname;
            $user->picture = $rec->picture;

            $worksheet->write($row, 0, fullname($user));
            $worksheet->write($row, 1, $rec->count);

            $row++;

        }
        $workbook->close();
    } else if ($out == 'txt') { /// CSV output
        header("Content-Type: application/download\n");
        header("Content-Disposition: attachment; filename={$strfilename}.txt");
        header("Expires: 0");
        header("Cache-Control: must-revalidate,post-check=0,pre-check=0");
        header("Pragma: public");

        echo get_string('users') . "\t" . get_string('total') . "\n";

        $row = 1;

        while ($rec = rs_fetch_next_record($rs)) {

            if (has_capability('moodle/course:manageactivities', $context, $rec->id)) {
                continue;
            }

            $user = new object();
            $user->id = $rec->id;
            $user->firstname = $rec->firstname;
            $user->lastname = $rec->lastname;
            $user->picture = $rec->picture;

            echo fullname($user) . "\t" . $rec->count . "\n";

            $row++;

        }
    } else { /// HTML output
        $navlinks = array();
        $navlinks[] = array('name' => $strreports, 'link' => "../../report.php?id=$course->id", 'type' => 'misc');
        $navlinks[] = array('name' => $strparticipation, 'link' => null, 'type' => 'misc');
        $navigation = build_navigation($navlinks);
        print_header("$course->shortname: $strparticipation", $course->fullname, $navigation);

    /// Print groups selector
        groups_print_course_menu($course, 'index.php?id=' . $course->id);

    /// Print download selector
        echo '<div style="text-align:right">';
        $options = array('xls' => get_string('downloadexcel'),
                         'ods' => get_string('downloadods'),
                         'txt' => get_string('downloadtext'));
        popup_form($CFG->wwwroot . "/course/report/rawrecordscount/index.php?id={$id}&amp;group={$currentgroup}&amp;out=",
                   $options,
                   'downloadreport',
                   '',
                   'choose',
                   '',
                   '',
                   false,
                   'self',
                   get_string('format'));

        echo '</div>';

        echo '<div class="clearer">&nbsp;</div>';

        $table = new object();
        $table->width = '60%';
        $table->head = array('&nbsp;', get_string('users'), get_string('total'));
        $table->align = array('center', 'left', 'center');
        $table->size = array('20%', '60%', '20%');

        while ($rec = rs_fetch_next_record($rs)) {

            if (has_capability('moodle/course:manageactivities', $context, $rec->id)) {
                continue;
            }

            $user = new object();
            $user->id = $rec->id;
            $user->firstname = $rec->firstname;
            $user->lastname = $rec->lastname;
            $user->picture = $rec->picture;

            $table->data[] = array(print_user_picture($user, $course->id, $user->picture, false, true),
                                   '<strong><a href="'.$CFG->wwwroot.'/user/view.php?id='.$user->id.'&amp;course='.$course->id.'">'.fullname($user).'</a></strong>',
                                   $rec->count);
        }
        print_table($table);

        print_footer();
    }

/// Close the recordset (common for all outputs)
    rs_close($rs);
?>
